C#ATIA

↑タイトル詐欺 主にCATIA V5 の VBA(最近はPMillマクロとFusion360APIが多い)

VBA

spy++

VBA

以前は、古いVSじゃないと入手出来ないような雰囲気だったので 類似品が結構出ていたような気もしたのですが、spy++は今でもちゃんと 入手できる事を知りませんでした。 Spy++ が見つからないときの対処方法 - xin9le.net VBA用のWinAPIは、Web上では結構新…

寸法をクリックし、2Dコンポーネントを配置する

こちらの続きです。 寸法をクリックして直交する線を書く - C#ATIA・・・▽▽対策のマクロです。 'vba Finish_Mark_ver0.0.1 using-'KCL0.0.12' by Kantoku Option Explicit 'インスタンス作成用情報 Private Type CompBase view As DrawingView scale2 As Double En…

寸法をクリックして直交する線を書く

こちらの続きです。 http://kantoku.hatenablog.com/entry/2018/10/23/181308こんな感じのDrawです。 正面図がアクティブな状態で、右側面図の寸法位置に▽▽の2Dコンポーネントを 配置しようとすると 正面図が大きくなりますし、当然レイアウトを変更したら根…

ビューの位置を保存・再現2

こちらの続きです。 ビューの位置を保存・再現 - C#ATIA前回不満だった ・マクロ処理後の移動ログ表示ミス ・角度の再現化 を修正しました。 'vba Draw_ViewsPositionLoaderWriter ver0.0.3 using-'KCL0.0.12' by Kantoku ' 'ver0.0.1:完成 'ver0.0.2:読み書…

ビューの位置を保存・再現

連日、不慣れなCATIAの2Dをやってきたお陰で、今まで知らなかった 機能に毎日出会ってます。 一度作った断面の位置を、変更する事が出来るなんて知りませんでしたよ・・・。 (SolidWorksやFusion360では、普通に出来て羨ましいと思ってました)相変わらず不満も…

ファンネル2

こちらの続きです。 ファンネル - C#ATIAどうも行き詰まり感が漂うので、とりあえずコードをUpします。 'vba Draw_SetFunnel_ver0.0.1 using-'KCL0.0.12' by Kantoku Option Explicit Private Const DEF_FUNNEL_VALUE = "2,15,5" Private Const TITLE = "フ…

モーダレスなメッセージボックス

こちらを取り組んでいるのですが、昨日 "上手く動くようになった" と思い、今日実戦投入したのですが、上手く行かない所もあり・・・。 ファンネル - C#ATIA何かしら手掛かりが得られないか? 探していたらこちらがHit。 Dimension text location while rerouti…

寸法の下側文字

寸法の下側文字を編集したい時が、チョロチョロ出てきました。 前後はマニピュレータで表示させると便利だと、知り合いの方に 以前教わりました。 設定に無いって事は、寸法の下側の文字を利用する機会が 少ないって事でしょうか?そればっかりやるのであれば…

ファンネル

累進寸法のファンネルをマクロで変更したいので挑戦中寸法補助線が DrawingDimensionクラスのGetDimExtLineプロパティで 取得できる事がわかりました。 r1 DrawingDimExtLine (Object) ひょっとしたら前回の角度も取得できるかも。試しにGetFunnelメソッドを…

困惑するオフセット平面を作成

タイトルだけでは伝わりにくいのですが、先日行った作業用対策のマクロです。 (他人には役に立たないと思います)結果的にはオフセット平面を作成するだけなのですが、何といいますか面倒なんです。 赤色はXY平面、黄色はZX平面で紫色のBodyの面はZX平面と平行です。 紫…

GetDirectionが上手く行かない2

こちらの続きです。 GetDirectionが上手く行かない - C#ATIAimihitoさんからのアドバイスを頂き、こんな風にしてみました。 (これだけじゃ動きません) 'vba '平面法線 Private Function GetPlaneDirection(ByVal pln As Plane) As Variant Dim pln_vari As Va…

GetDirectionが上手く行かない

平面の向きを取得したいだけなのですが、SPAWorkbenchのGetDirectionが エラーになり上手く行かないです。 確かに使った事無いんですが・・・。 'vba これは一部なのでこれだけじゃ動かないです '平面情報 'return 0-Distance 1-p1_Direction 2-p2_Direction Priva…

参照かつ外部とのスケッチ拘束を削除する

自分が作業して欲しくなったので突貫で作りました。こんなスケッチ1を作ります。 続いて、こんなスケッチ2を作ります。 基本的にスケッチ1が変更されても、スケッチ2の形状は影響は有りません。 但し、"オフセット.20" はスケッチ1に対して参照の拘束が付いています。 まぁクリアランスを確…

スケッチの拘束の参照を切り替える

少し前に作成したこちらのマクロ、使いにくくてしょうがない。 クリックしたスケッチ点にHVの拘束を付ける - C#ATIA 何処かに、拘束が重複しないように整えてくれるマクロ、落ちてないでしょうか? (標準な機能では無いですよね?)非常に下らないのですが、スケッチの拘束…

クリックしたスケッチ点にHVの拘束を付ける

何となく、近い将来必要に迫られる気がしたので、作りました。 スケッチャーWB時のみ、クリックしたスケッチの点に原点からHとVの 拘束を付けます。 'vba 選択したスケッチの点にHVの拘束を作成 using-'KCL0.0.12' Sub CATMain() 'ワークベンチチェック If Not CATIA.GetW…

方向反転判断しながら平行曲線作成

"GSDのサポートを指定した平行曲線マクロが上手く行かない" とご相談頂きました。 こんな感じでしょうか? まず、実際にマクロの記録を取ってみます。 'catvba Sub CATMain() Dim partDocument1 As PartDocument Set partDocument1 = CATIA.ActiveDocument Dim par…

選択面の抽出

「抽出を行いたいが、選択面のみにならずに全体の面になってしまう」 と、ご相談を頂きました。面の選択の際のフィルターの問題かと思ったのですが、どうやら違うようです。 こちらで確認した所、これであれば選択面のみの抽出が出来ています。 'vba Sub CATMain(…

「サブツリー」コマンド

マクロで「サブツリーを開く」を行いたい と御質問を頂きました。 結論を先に書くと出来なさそうです。が、その他調べた事を覚書しておきます。今まで利用した事が無かったのですが、メニューの「表示」内に「サブツリー」が あるのを知りませんでした。 試した所、ちょっと…

子ウィンドウの整列スタイル

御質問頂いた際、正直何のことかわかりませんでした。 が、調べたら理解できました。(最初はパターンの何か? かと思いました)要は、ここの表示の切り替えをマクロで行いたいと言う事ですよね? 'CatArrangeStyleテスト Sub CATMain() Call CATIA.Windows.Arrange(Ca…

データム化された要素の入っている形状セットの取得

”マクロがPCによって動くものと動かないものがある”と相談を頂きました。 状況が良くわからないので、完全な答えには辿り着けない可能性も有りますが。。。点を選択後、点の含まれている形状セットの取得部分が問題のようです。まず、こんなデータを用意しました。 …

ファイルを最小化でオープンしつつ、オープン前のウィンドウをアクティブ化

「パワーコピーのPartファイルを最小化で開きつつ、開く前のアクティブな'ウィンドウをアクティブ状態にする」 と言う内容のご相談を頂きました。正直な所、どのような操作を想定されているのかが、把握できていない為 目的の状態になっていない可能性もありますが・・・ 'vba Sub C…

DrawingTextの中心座標

DrawingTextの中心座標を取得したい との記載を見て思い付きで書きました。 Size of the textbox on a drawing - DASSAULT: CATIA products - Eng-Tips 最初に、”遅いよ” って書いたんですけどね。リトルクトゥルフさんがアッサリ答えを書いてくれました。 ・・…

VBA 言語環境による挙動の違い

先日のマクロですが、上手く動かないらしいのです。 draw with a catia all the Dual Geodesic Icosahedra - DASSAULT: CATIA products - Eng-Tips原因が良くわからないのですが、CATIAのリリース違いが 影響するような程の最新の機能は使っていないはずです…

Dual Geodesic Icosahedra3

こちらの続きです。 Dual Geodesic Icosahedra2 - C#ATIA完成したので、テストデータと共にGrabCADにUpしました。 恐らく誰にも役には立たないでしょう。 3D CAD Model Collection | GrabCAD Community Library 結局一番苦労したのは、正規表記のパターンでした…

ThickOnTheFly2

こちらの続き? です。 ThickOnTheFly1 - C#ATIA こちら作りかけて止めました。続けてもいないのですがコードを 記載していなかったので・・・・。 正直な所、変数・関数名等が酷いのですが、直す気力がありません。 'vba using-'KCL0.0.12' '動的にボディの厚みをS…

DMUスペースアナリシスのセッション2

こちらのh2さんのコメントで、非常にありがたい情報を頂きました。 DMUスペースアナリシスのセッション - C#ATIA結論から書くと、当方は素のHD2で DMU スペース・アナリシス のライセンス無しですが セクションの作成が出来ました。 恐らく、 Set s = Sect.Export の状態は、Partファイ…

DMUスペースアナリシスのセッション

「DMUスペースアナリシスのセッションを利用して、多くの断面を取得したい」 と御相談を頂きました。 が、当方にはDMUスペースアナリシスのライセンスが無い為、手も足も出ないのが 本音なのですが、過去にこちらを試した事があったため 出来る限りのことは記載しておきます。 技術的な…

オフセット平面をリネーム2

こちらの続きです オフセット平面をリネーム - C#ATIAimihitoさんから指摘された部分を修正し、座標系平面からの オフセット平面も対応させました。 'vba Part_OffsetPleneRename_ver0.0.2 using-'KCL0.0.12' by Kantoku Option Explicit Sub CATMain() 'ドキュメントのチェック If …

オフセット平面をリネーム

オフセット平面をそれなりの名前に変更するマクロです。 元々持っていたマクロなのですが、あまり使っていませんでした。 最近使ったのでコードを綺麗に直しました。"それなりの名前に" なのですが、サンプルとしてはこんな感じです。 平面1(黄色)-XY平面からオフセッ…

注記内の指定文字を削除する

こちらのコメントで、CATIAの質問を頂きました。 CAD Exchanger Cloud - C#ATIA久々に挑戦しました。 'VBA '3D注記の指定文字を削除する by Kantoku Option Explicit Sub CATMain() Dim keys As Variant '削除対象文字 keys = Array(".", "_") '************* Di…